# Copyright (c) 2000-2007, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

%define with()          %{expand:%%{?with_%{1}:1}%%{!?with_%{1}:0}}
%define without()       %{expand:%%{?with_%{1}:0}%%{!?with_%{1}:1}}
%define bcond_with()    %{expand:%%{?_with_%{1}:%%global with_%{1} 1}}
%define bcond_without() %{expand:%%{!?_without_%{1}:%%global with_%{1} 1}}

%bcond_without repolib

%define repodir %{_javadir}/repository.jboss.com/ejb3-persistence/%{namedversion}-brew
%define repodirlib %{repodir}/lib
%define repodirsrc %{repodir}/src

%define section free
%define reltag GA
%define namedversion %{version}.%{reltag}
%define hname ejb3-persistence

Summary:        EJB3 persistence API
Name:           hibernate3-ejb-persistence-3.0-api
Version:        1.0.2
Release:        3.3%{?dist}
Epoch:          1
License:        LGPL
URL:            http://www.hibernate.org/
Group:          Database
# svn export https://svn.jboss.org/repos/hibernate/jpa-api/tags/v1_0_2_GA hibernate3-ejb-persistence-3.0-api
# tar czf hibernate3-ejb-persistence-3.0-api-1.0.2.GA.tar.gz hibernate3-ejb-persistence-3.0-api
Source0: 	hibernate3-ejb-persistence-3.0-api-1.0.2.GA.tar.gz
Source1: 	hibernate3-ext-lgpl.txt
Source2: 	hibernate3-ejb-persistence-3.0-api-component-info.xml

Requires(post): jpackage-utils >= 0:1.7.3
Requires(postun): jpackage-utils >= 0:1.7.3
Requires(preun): %{_sbindir}/update-alternatives
Requires(post): %{_sbindir}/update-alternatives
BuildRequires:  jpackage-utils >= 0:1.7.3
BuildRequires:  java-devel >= 1.5.0
BuildRequires:  ant
BuildRequires:  ivy
BuildRequires:  maven2 >= 0:2.0.8
BuildRequires:  maven-ant-tasks
BuildRequires:  maven-deploy-plugin
Requires:       java >= 0:1.5
Provides:	jpa_1_0_api

BuildArch:      noarch
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-buildroot

%description
JSR-220 EJB 3.0 (persistence) API

%package javadoc
Summary:        Javadoc for %{name}
Group:          Development/Documentation

%description javadoc
%{summary}.

%if %with repolib
%package repolib
Summary:        Artifacts to be uploaded to a repository library
Group:          Development/Libraries/Java

%description repolib
Artifacts to be uploaded to a repository library.
This package is not meant to be installed but so its contents
can be extracted through rpm2cpio.
%endif

%prep
%setup -q -n %{name}
# remove all binary libs
for j in $(find . -name "*.jar"); do
	mv $j $j.no
done

%build
export JAVA_HOME=/usr/lib/jvm/java-1.6.0

build-jar-repository -s -p ivy \
	ivy \
	maven-ant-tasks

ant \
	-Doffline.repository.jboss.org=$PWD/build jar javadoc deploy

%install
rm -rf $RPM_BUILD_ROOT

# jars
mkdir -p $RPM_BUILD_ROOT%{_javadir}
cp -p build/ejb3-persistence.jar \
  $RPM_BUILD_ROOT%{_javadir}/%{name}-%{version}.jar
cp -p build/src.jar \
  $RPM_BUILD_ROOT%{_javadir}/%{name}-sources-%{version}.jar
(cd $RPM_BUILD_ROOT%{_javadir} && for jar in *-%{version}.jar; do ln -sf ${jar} `echo $jar| sed "s|-%{version}\.jar|.jar|g"`; done)

touch $RPM_BUILD_ROOT%{_javadir}/jpa_1_0_api.jar

## javadoc
mkdir -p $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
cp -pr build/api/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
ln -s %{name}-%{version} $RPM_BUILD_ROOT%{_javadocdir}/%{name} # ghost symlink

mkdir -p $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}
cp -p etc/license.txt $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}/spec_license.txt
cp %{SOURCE1} $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}/lgpl.txt

#poms
%{__mkdir_p} %{buildroot}%{_datadir}/maven2/poms
%add_to_maven_depmap org.hibernate ejb3-persistence %{namedversion} JPP %{name}
%{__install} -p -m 644 pom.xml %{buildroot}%{_datadir}/maven2/poms/JPP-%{name}.pom

%if %with repolib
install -d -m 755 $RPM_BUILD_ROOT%{repodir}
%{_bindir}/mvn-jpp deploy:deploy-file \
-DgroupId=org.hibernate \
-DartifactId=%{hname} \
-Dversion=%{namedversion} \
-Dpackaging=jar \
-Dfile=$RPM_BUILD_ROOT%{_javadir}/%{name}-%{version}.jar \
-DpomFile=%{buildroot}%{_datadir}/maven2/poms/JPP-%{name}.pom \
-Durl=file://%{buildroot}%{_javadir}/repository.jboss.com/maven2-brew/ \
-DrepositoryId=jboss-releases
%{_bindir}/mvn-jpp deploy:deploy-file \
-DgroupId=org.hibernate \
-DartifactId=%{hname} \
-Dversion=%{namedversion} \
-Dpackaging=java-source \
-DgeneratePom=false \
-Dfile=$RPM_BUILD_ROOT%{_javadir}/%{name}-sources-%{version}.jar \
-DpomFile=%{buildroot}%{_datadir}/maven2/poms/JPP-%{name}.pom \
-Durl=file://%{buildroot}%{_javadir}/repository.jboss.com/maven2-brew/ \
-DrepositoryId=jboss-releases
install -d -m 755 $RPM_BUILD_ROOT%{repodirlib}
install -p -m 644 %{SOURCE2} $RPM_BUILD_ROOT%{repodir}/component-info.xml
sed -i 's/@VERSION@/%{namedversion}-brew/g' $RPM_BUILD_ROOT%{repodir}/component-info.xml
tag=`echo %{name}-%{version}-%{release} | sed 's|\.|_|g'`
sed -i "s/@TAG@/$tag/g" $RPM_BUILD_ROOT%{repodir}/component-info.xml
install -d -m 755 $RPM_BUILD_ROOT%{repodirsrc}
install -p -m 644 %{SOURCE0} $RPM_BUILD_ROOT%{repodirsrc}
install -p -m 644 %{SOURCE1} $RPM_BUILD_ROOT%{repodirsrc}
cp -p $RPM_BUILD_ROOT%{_javadir}/%{name}-%{version}.jar $RPM_BUILD_ROOT%{repodirlib}/%{hname}.jar
cp -p $RPM_BUILD_ROOT%{_javadir}/%{name}-sources-%{version}.jar $RPM_BUILD_ROOT%{repodirlib}/%{hname}-sources.jar
cp -p $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP-%{name}.pom  $RPM_BUILD_ROOT%{repodirlib}/%{hname}.pom
%endif

%clean
rm -rf $RPM_BUILD_ROOT

%post
%update_maven_depmap

%{_sbindir}/update-alternatives --install %{_javadir}/jpa_1_0_api.jar jpa_1_0_api %{_javadir}/%{name}-%{version}.jar 30000

%preun
%{_sbindir}/update-alternatives --install %{_javadir}/jpa_1_0_api.jar jpa_1_0_api %{_javadir}/%{name}-%{version}.jar 30000

%postun
%update_maven_depmap

%post javadoc
rm -f %{_javadocdir}/%{name}
ln -s %{name}-%{version} %{_javadocdir}/%{name}

%postun javadoc
if [ "$1" = "0" ]; then
  rm -f %{_javadocdir}/%{name}
fi

%files
%defattr(0644,root,root,0755)
%doc %{_docdir}/%{name}-%{version}/spec_license.txt
%doc %{_docdir}/%{name}-%{version}/lgpl.txt
%{_javadir}*/*.jar
%ghost %{_javadir}/jpa_1_0_api.jar
%{_datadir}/maven2/poms/JPP-%{name}.pom
%{_mavendepmapfragdir}/%{name}

%files javadoc
%defattr(0644,root,root,0755)
%{_javadocdir}/%{name}-%{version}
%ghost %doc %{_javadocdir}/%{name}

%if %with repolib
%files repolib
%defattr(0644,root,root,0755)
%{_javadir}*/repository.jboss.com
%endif

%changelog
* Fri Jan 05 2011 Strong Liu <stliu@redhat.com> - 1:1.0.2-3.3
- Add source jar

* Fri Jan 05 2011 Strong Liu <stliu@redhat.com> - 1:1.0.2-3.2
- Build with Maven 2.2.1
- Fix %%files for signed jars
- Add content of maven2-brew, add BR maven-deploy-plugin

* Sat Aug 07 2010 Strong Liu <stliu@redhat.com> - 1:1.0.2-3.1
- Rebuild

* Tue Apr 20 2010 Yiqiao Wang <yiwang@redhatc.om> - 1:1.0.2-3
- Rebuild
- Change JAVA_HOME from java-1.5.0 to java-1.6.0 

* Thu Mar 11 2010 Yiqiao Wang <yiwang@redhat.com> - 1:1.0.2-2.1
- Merge from RHEL-4-EP-5

* Wed Mar 03 2010 Martha Benitez <mbenitez@redhat.com> - 1:1.0.2-2
- Add Provides jpa_1_0_api

* Mon Aug 24 2009 Permaine Cheung <pcheung@redhat.com> - 1:1.0.2-1
- Fix version to 1.0.2, update epoch, update version in the name of src tar ball
- Add repolib

* Sat Jul 18 2009 Gail Badner <gbadner@redhat.com> - 0:3.4.0-1.1
- First build for RHEL-4-EP-5
